{
  "openapi": "3.0.2",
  "x-stoplight": {
    "id": "82lba7uslyryf"
  },
  "info": {
    "title": "Lucen Track APIs",
    "version": "1.0",
    "contact": {
      "name": "Support",
      "email": "info@timeneye.com",
      "url": "https://support.timeneye.com/"
    },
    "description": "\n# Overview\nLucen Track APIs use the OAuth 2.0 flow for authentication.\n\nIn order to start using our apis you need to create a new app under your [developer panel](https://track.lucensoftware.com/developers). The newly created app will have a Client ID, to identify your app, that can be used on public code (like a website script) and will use the [PKCE](https://datatracker.ietf.org/doc/html/rfc7636) Authorization flow to obtain an access token. \n\nThis guide provides step-by-step instructions on how to request an access token using OAuth 2.0 for your application on Lucen Track.\n\n### Prerequisites\n\nBefore proceeding with the access token request, ensure you have the following:\n\n- Client ID: A unique identifier assigned to your application by the OAuth provider.\n- Authorization Server URL: https://track-api.lucensoftware.com/oauth/authorize\n- Redirect URI: The URI where the authorization server redirects the user after authentication. (E.g. https://your-application-server/callback)\n\n### PKCE Authorization flow\nBelow the diagram, you'll discover a comprehensive breakdown that illustrates the functionality of the PKCE authentication flow.\n```mermaid\nsequenceDiagram\nparticipant User\nparticipant Your application\nparticipant Authorization Server\nparticipant API\nUser->>Your application: 1. Click login to Lucen Track link.\n\nloop challenge\nYour application->Your application: 2. Generate code verifier and code challenge.\nend\n\nYour application->>Authorization Server: 3. Authorization code request and code challenge to authorize.\nAuthorization Server->>User: 4. Redirect to login/authorization prompt.\nUser->>Authorization Server: 5. Authenticate and consent\nAuthorization Server->>Your application: 6. Authorize code.\nYour application->>Authorization Server: 7. Authorization code and code verified to OAuth token.\n\nloop validate\nAuthorization Server->Authorization Server: 8. Validate code verifier and challenge.\nend\n\nAuthorization Server->>User: 9. ID token and access token.\nUser->>API: 10. Request user data with access token.\nAPI->>User: 11. Response.\n```\n\n1. The user clicks **Login to Lucen Track** within your application.\n\n2. Your application creates a cryptographically-random `code_verifier` and from this generates a `code_challenge`.\n\n3. Your application redirects the user to the Lucen Track Authorization Server (/oauth/authorize endpoint) along with the `code_challenge`.\n\n4. The Lucen Track Authorization Server redirects the user to the login and authorization prompt.\n\n5. The user authenticates using one of the available login options and may see a consent page listing the permissions the user will give to the application.\n\n6. The Lucen Track Authorization Server stores the code_challenge and redirects the user back to the application with an authorization code, which is good for one use.\n\n7. Your application sends this `code` and the `code_verifier` (created in step 2) to the Lucen Track Authorization Server (/oauth/token) endpoint. \n\n8. The Lucen Track Authorization Server verifies the `code_challenge` and `code_verifier`.\n\n9. The Lucen Track Authorization Server responds with an ID token and access token and a refresh token.\n\n10. Your application can use the access token to call an API to access information about the user.\n\n11. The API responds with requested data.\n\n### Steps to Request an Access Token\n\n1. Initiate the Authorization Request:\n   - Redirect the user to the authorization server's endpoint for authorization. This typically involves redirecting the user to a specific URL with the required query parameters:\n\nFirst generate a code challenge and a state (Example in PHP language)\n\n```php\n// Keep the state in session\n$request->session()->put('state', $state = Str::random(40));\n// $state is now (e.g.) \"Grmfqj7RPAYlsEOf9iyNNIHAZG2cogt6sgJVgWxw\"\n\n// Keep the code verifier in session\n$request->session()->put(\n    'code_verifier', $code_verifier = Str::random(128)\n);\n\n// Create the code challenge\n$codeChallenge = strtr(rtrim(base64_encode(hash('sha256', $code_verifier, true)), '='), '+/', '-_');\n```\nThen create the request for the authorization\n\n```php\nuse GuzzleHttp\\Client;\n\n$query = [\n    \"client_id\": \"your-client-id\",\n    \"redirect_uri\": \"https://your-application-server/authorization-callback\",\n    \"response_type\": \"code\",\n    \"scope\": \"\",\n    \"state\": $state,\n    \"code_challenge\": $codeChallenge,\n    \"code_challenge_method\": \"S256\"\n];\n\n// Create a Guzzle HTTP client instance\n$client = new Client();\n\n// Build the request URL with query parameters\n$requestUrl = 'https://track-api.lucensoftware.com/oauth/authorize?' . http_build_query($query);\n\n// Send the GET request and get the response\n$response = $client->get($requestUrl);\n\n// Get the response body\n$responseBody = $response->getBody()->getContents();\n```\n\n2. User Authentication and Consent:\n   - The user will be prompted to authenticate with the authorization server and may be asked to provide consent to grant access to their resources.\n\n3. Authorization Code Exchange:\n   - After successful authentication and consent, the authorization server will redirect the user back to the provided redirect URI (https://your-application-server/authorization-callback), appending an authorization `code` and the `state` as query parameters.\n\n4. Access Token Request:\n   - Using the obtained authorization code, make a POST request to the authorization server's token endpoint, including the required parameters\n\nFirst retrieve the state and the verifier from the session. (Example in PHP)\nCheck if the state in the session is the same as the one received in the request \n\n```php\n// Get the state from the session\n$state = $request->session()->pull('state');\n\n// Get the verifier from the session\n$codeVerifier = $request->session()->pull('code_verifier');\n\n// Check state to prevent cross site request forgery\nthrow_unless(\n    strlen($state) > 0 && $state === $request->state,\n    InvalidArgumentException::class\n);\n\n// Get the code from the request\n$code = $request->code;\n```\n\nThen create the authentication request\n\n```php\nuse GuzzleHttp\\Client;\n\n// JSON data\n$jsonData = [\n    \"grant_type\": \"authorization_code\",\n    \"client_id\": \"your-client-id\",\n    \"redirect_uri\": \"https://your-application-server/authentication-callback\",\n    \"code\": \"code\",\n    \"code_verifier\": $codeVerifier\n];\n\n// Create a Guzzle HTTP client instance\n$client = new Client();\n\n// Send the POST request\n$response = $client->post(\"https://track-api.lucensoftware.com/oauth/token\", [\n    'json' => $jsonData\n]);\n\n// Get the response body\n$responseBody = $response->getBody()->getContents();\n\n```\n\n5. Access Token Response:\n   - The token endpoint will respond with an access token, along with other optional parameters like token expiration time (`expires_in`), token type, and refresh token.\n\n6. Use the Access Token:\n   - Include the obtained access token in subsequent API requests by adding it to the `Authorization` header, typically in the format: `Authorization: Bearer <access_token>`\n\n7. Token Refresh:\n   - If the access token expires, you can use the provided refresh token to obtain a new access token without going through the authorization flow again. Make a POST request to the token endpoint, similar to the access token request, but with `grant_type` set to `\"refresh_token\"` and include the refresh token as the `refresh_token` parameter.\n\n\n# Rate limiting\n\nIn order to be able to offer a reliable service to all our users and customers we limit how many requests can be performed per token every 5 minutes.\n\nEvery token has a limited number of requests (in the table below) that can be performed in a given window of time. The requests count is reset every 5 minutes.\n\nThe number of requests that can be performed every 5 minutes changes based on which plan has the user's account, at the moment of the request.\n\n| Plan | Maximum requests per 5 minutes |\n|--|--|\n|**Free**|500|\n|**Business (any tier)/PRO**|2000|\n\nIn case the limit is reached, the following requests (for the given token) will receive a  `429`  error.\n\nThe response will contain the following headers:\n| Header | Example value | Description |\n|--|--|--|\n|  X-RateLimit-Limit  |  2000  |  How many requests you can make  |\n|  X-RateLimit-Remaining  |  0  |  How many remaining requests are left  |\n|  Retry-After  |  177  |  Indicates  how  many  seconds  to  wait  before  making  a  follow-up  request.|\n|  X-RateLimit-Reset  |  1691677002  |  Indicates when the limit resets (UNIX timestamp)  |\n\n# Errors\n\nAll our API endpoints return a 200 HTTP status code when everything works as expected, but sometimes it may return an error.\n\nOur APIs return different error codes based on the failure cause, ranging from missing parameters to server errors on our side.\n\nIn the table below you find a list of all our error codes with a generic description of the cause, in case the endpoint doesn't return a description of the specific case.\n\n| Code | Meaning | Description |\n|--|--|--|\n| 400| Bad request | One or multiple required parameters are missing or invalid.|\n| 401| Unauthorized | The authorization token is missing, invalid or expired.|\n| 403| Forbidden | Both the authentication and the request syntax are correct, but the resource you're trying to edit requires an access level that the authorized user doesn't have.|\n| 403| Not found | The requested resource is not available. |\n| 403| Not found | The requested resource is not available. |\n| 422| Validation | The parameters or the payload passed does not follow the required specification |\n| 429| Too many requests | You have reached your rate limit. |\n| 500| Internal server error | There was a problem on our side. |",
    "termsOfService": "https://www.timeneye.com/legal/terms-and-conditions",
    "license": {
      "name": "Custom",
      "url": "https://www.timeneye.com/legal/terms-and-conditions"
    }
  },
  "servers": [
    {
      "url": "https://track-api.lucensoftware.com/api/v1",
      "description": "Production"
    }
  ],
  "tags": [
    {
      "name": "Accounts",
      "description": "Accounts"
    },
    {
      "name": "ApprovalEvents",
      "description": "ApprovalEvents"
    },
    {
      "name": "ApprovalRequests",
      "description": "ApprovalRequests"
    },
    {
      "name": "Attachments",
      "description": "Attachments"
    },
    {
      "name": "Avatars",
      "description": "Avatars"
    },
    {
      "name": "Budgets",
      "description": "Budgets"
    },
    {
      "name": "Clients",
      "description": "Clients"
    },
    {
      "name": "Countries",
      "description": "Countries"
    },
    {
      "name": "Currencies",
      "description": "Currencies"
    },
    {
      "name": "E2ETesting",
      "description": "E2E Testing endpoints - only available in e2e_testing environment"
    },
    {
      "name": "Entries",
      "description": "Entries"
    },
    {
      "name": "EntrySuggestions",
      "description": "EntrySuggestions"
    },
    {
      "name": "ExpenseCategories",
      "description": "ExpenseCategories"
    },
    {
      "name": "Expenses",
      "description": "Expenses"
    },
    {
      "name": "Groups",
      "description": "Groups"
    },
    {
      "name": "Languages",
      "description": "Languages"
    },
    {
      "name": "PhaseCategories",
      "description": "PhaseCategories"
    },
    {
      "name": "Phases",
      "description": "Phases"
    },
    {
      "name": "Projects",
      "description": "Projects"
    },
    {
      "name": "TagLists",
      "description": "TagLists"
    },
    {
      "name": "Tags",
      "description": "Tags"
    },
    {
      "name": "Timers",
      "description": "Timers"
    },
    {
      "name": "TodoLists",
      "description": "TodoLists"
    },
    {
      "name": "Todos",
      "description": "Todos"
    },
    {
      "name": "Users",
      "description": "Users"
    },
    {
      "name": "Zones",
      "description": "Zones"
    }
  ],
  "components": {
    "securitySchemes": {
      "BearerAuth": {
        "type": "oauth2",
        "flows": {
          "password": {
            "tokenUrl": "https://track-api.lucensoftware.com/oauth/token",
            "refreshUrl": "https://track-api.lucensoftware.com/oauth/token",
            "scopes": {}
          }
        },
        "description": ""
      }
    },
    "parameters": {
      "page": {
        "name": "page",
        "description": "The currently displayed page",
        "in": "query",
        "schema": {
          "type": "integer",
          "minimum": 1
        }
      },
      "per_page": {
        "name": "per_page",
        "description": "How many items per page",
        "in": "query",
        "schema": {
          "type": "integer"
        }
      },
      "sort_by": {
        "name": "sort_by",
        "description": "The attribute to sort by",
        "in": "query",
        "schema": {
          "type": "string"
        }
      },
      "direction": {
        "name": "direction",
        "description": "The sort direction",
        "in": "query",
        "schema": {
          "type": "string",
          "default": "asc",
          "enum": [
            "asc",
            "desc"
          ]
        }
      }
    },
    "responses": {
      "401": {
        "description": "Unauthorized",
        "content": {
          "application/json": {
            "schema": {
              "type": "object",
              "properties": {
                "message": {
                  "type": "string"
                }
              }
            }
          }
        }
      },
      "403": {
        "description": "Forbidden",
        "content": {
          "application/json": {
            "schema": {
              "type": "object",
              "properties": {
                "message": {
                  "type": "string"
                }
              }
            }
          }
        }
      },
      "404": {
        "description": "Not found",
        "content": {
          "application/json": {
            "schema": {
              "type": "object",
              "properties": {
                "message": {
                  "type": "string"
                }
              },
              "x-examples": {
                "example-1": {
                  "message": "No query results for model [App\\Models\\Account] 3"
                }
              }
            }
          }
        }
      },
      "422": {
        "description": "Invalid request",
        "content": {
          "application/json": {
            "schema": {
              "type": "object",
              "x-examples": {
                "Example 1": {
                  "message": "The color must be 7 characters.",
                  "errors": {
                    "color": [
                      "The color must be 7 characters."
                    ]
                  }
                }
              },
              "properties": {
                "message": {
                  "type": "string"
                },
                "errors": {
                  "type": "object",
                  "description": "The errors object has properties as keys and array of strings as values"
                }
              }
            }
          },
          "application/xml": {
            "schema": {
              "type": "object",
              "x-examples": {
                "Example 1": {
                  "message": "The project is required if you are changing the entry's owner (and 4 more errors)",
                  "errors": {
                    "project_id": [
                      "The project is required if you are changing the entry's owner"
                    ],
                    "phase_id": [
                      "The phase is required if you are changing the entry's owner"
                    ],
                    "user_id": [
                      "The user field is required."
                    ],
                    "minutes": [
                      "The minutes field is required."
                    ],
                    "date": [
                      "The date field is required."
                    ]
                  }
                }
              },
              "properties": {
                "message": {
                  "type": "string"
                },
                "errors": {
                  "type": "object"
                }
              }
            }
          }
        },
        "headers": {}
      }
    },
    "schemas": {
      "Account": {
        "type": "object",
        "x-examples": {},
        "title": "Account",
        "x-stoplight": {
          "id": "wlpj5oz3p1xgd"
        },
        "properties": {
          "account_name": {
            "type": "string",
            "description": "The name of the account, usually the Company name."
          },
          "created_date": {
            "type": "string",
            "description": "Date of creation",
            "example": "2023-01-01 10:00:00"
          },
          "expiration": {
            "type": "string",
            "description": "Date of license (or trial period) expiration",
            "example": "2023-01-01"
          },
          "is_trial": {
            "type": "boolean"
          },
          "trial_expiration": {
            "type": "string",
            "description": "Date of trial period expiration",
            "example": "2023-01-01"
          },
          "settings": {
            "type": "object",
            "properties": {
              "companyName": {
                "type": "string",
                "description": "The name of the company, could be different from account_name"
              },
              "prosett_clientMode": {
                "type": "integer",
                "description": "Whether or not the client should be displayed in the re"
              },
              "prosett_entriesLock_enabled": {
                "type": "integer",
                "description": "Whether or not the entry lock system is enabled"
              },
              "prosett_entriesLock_date": {
                "type": "string",
                "nullable": true,
                "description": "The date of the last entry lock"
              },
              "adminNewEntryForOthers": {
                "type": "integer",
                "description": "Whether o"
              },
              "register_time_for_others_roles": {
                "type": "array",
                "description": "Roles that are allowed to register time on behalf of other users. Requires the add_time_for_other_users feature to be enabled.",
                "items": {
                  "type": "string",
                  "enum": [
                    "owner",
                    "admin",
                    "gm",
                    "pm",
                    "all_managers"
                  ]
                }
              },
              "allow_apps": {
                "type": "integer",
                "description": "Whether or not the third party a"
              },
              "memberAverageCost": {
                "type": "integer",
                "description": "Indicates the average labour cost for the account members"
              },
              "showWorkingTime": {
                "type": "boolean",
                "description": "Whether or not the users can see their working time in their dashboard. (e.g. 7h of 8h)"
              },
              "authenticationMethod": {
                "type": "object",
                "description": "Authen",
                "properties": {
                  "type": {
                    "type": "string",
                    "description": "Type of login method",
                    "enum": [
                      "all",
                      "google",
                      "microsoft",
                      "saml"
                    ]
                  },
                  "idp_entity_id": {
                    "type": "string",
                    "description": "Id of the identity provider (used with type = saml)"
                  },
                  "idp_sso_url": {
                    "type": "string",
                    "description": "Single Sign on URL (used with type = saml)"
                  },
                  "idp_cert": {
                    "type": "string",
                    "description": "Certificate of the identity provider (used with type = saml)"
                  },
                  "allow_password_login": {
                    "type": "integer",
                    "description": "Whether or not the login with email + password is allowed"
                  }
                }
              },
              "entries_lock_automation": {
                "type": "object",
                "description": "Describes the automatic entry lock parameters",
                "properties": {
                  "enabled": {
                    "type": "boolean",
                    "description": "Whether or not the entry lock automation is enabled"
                  },
                  "interval": {
                    "type": "string",
                    "description": "Interval of the entry lock",
                    "enum": [
                      "weekly",
                      "monthly",
                      "0"
                    ]
                  },
                  "interval_target": {
                    "type": "integer",
                    "description": "Between 1 and 31 if the interval is monthly (the day of the month), Between 0 and 6i if the interval is weekly ",
                    "nullable": true
                  }
                }
              },
              "currencyCode": {
                "type": "string",
                "description": "Code of the used currency"
              },
              "required_fields": {
                "type": "array",
                "x-stoplight": {
                  "id": "h7839rgkzcv4j"
                },
                "description": "An array representing the required fields.\nAllowed values are entry_notes, to require entries to have notes, and expense_project, to require expenses to have a project.",
                "items": {
                  "x-stoplight": {
                    "id": "um79kws0ji8ys"
                  },
                  "enum": [
                    "entry_notes",
                    "expense_project"
                  ]
                }
              }
            }
          },
          "subscription_limit_users": {
            "type": "integer",
            "description": "Maximum number of active users allowed in the account due to purchased licenses"
          },
          "billing_enabled": {
            "type": "boolean",
            "description": "Whether or not a subscription is active for the account"
          }
        }
      },
      "Avatar": {
        "type": "object",
        "x-examples": {},
        "description": "An avatar that can be linked to an Account or to a User",
        "properties": {
          "avatar_name": {
            "type": "string",
            "description": "unique file name"
          },
          "avatar_url": {
            "type": "string",
            "description": "Image url"
          },
          "account_id": {
            "type": "integer",
            "description": "Identifier of the account which has this avatar"
          },
          "user_id": {
            "type": "integer",
            "description": "Identifier of the user which has this avatar"
          }
        },
        "x-stoplight": {
          "id": "rmwkjif7pfhgs"
        }
      },
      "Budget": {
        "type": "object",
        "x-examples": {},
        "x-stoplight": {
          "id": "h9p1bc7gu2rnb"
        },
        "properties": {
          "budget_id": {
            "type": "integer",
            "description": "Unique identifier of the budget"
          },
          "project_id": {
            "type": "integer",
            "description": "Identifier of the project to which the budget belongs"
          },
          "phase_id": {
            "type": "integer",
            "x-stoplight": {
              "id": "tlexvv7yuetem"
            },
            "description": "The id of the Phase the budget is related to",
            "nullable": true
          },
          "user_id": {
            "type": "integer",
            "x-stoplight": {
              "id": "1pys0459yhy5m"
            },
            "description": "The id of the project member the budget is related to",
            "nullable": true
          },
          "tag_id": {
            "type": "integer",
            "x-stoplight": {
              "id": "7s86fnl79406r"
            },
            "description": "The id of the Tag the budget is related to in the Project",
            "nullable": true
          },
          "tag_list_id": {
            "type": "integer",
            "x-stoplight": {
              "id": "fon5sltffk2nj"
            },
            "description": "The id of the Tag List the budget is related to in the Project",
            "nullable": true
          },
          "type": {
            "x-stoplight": {
              "id": "h25or18msishd"
            },
            "enum": [
              "time",
              "revenue",
              "cost"
            ],
            "description": "The type of the budget.\n- cost: Only for non-billable projects\n- time: for all kind of projects\n- revenue: Only for Time and material projects"
          },
          "recurrence": {
            "type": "integer",
            "enum": [
              0,
              1,
              2
            ],
            "description": "Recurrence of the budget: 0 = no recurrence, 1 = weekly, 2 = monthly"
          },
          "interval": {
            "type": "integer",
            "minimum": 0,
            "maximum": 31,
            "description": "Day of budget reset: 1 to 31 if the budget is monthly, 0 to 6 if the budget is weekly"
          },
          "budget_minutes": {
            "type": "integer",
            "description": "The time budget (must be absent if budget_amount is present)"
          },
          "budget_amount": {
            "type": "number",
            "x-stoplight": {
              "id": "bbf4car2or87w"
            },
            "description": "The monetary budget amount (must be absent if budget_minutes is present)"
          },
          "total_minutes": {
            "type": "integer",
            "x-stoplight": {
              "id": "peqvb91giz9qo"
            },
            "description": "The minutes tracked on this budget"
          },
          "total_revenue": {
            "type": "number",
            "x-stoplight": {
              "id": "qx25d5o2mpf01"
            },
            "description": "the revenue tracked on this budget"
          },
          "total_cost": {
            "type": "number",
            "x-stoplight": {
              "id": "isyisl8ypzefq"
            },
            "description": "The cost tracked on this budget"
          },
          "includes_expenses": {
            "type": "boolean",
            "x-stoplight": {
              "id": "vlth7bdw1dj38"
            },
            "description": "Tells if the monetary budget includes the expenses for the project"
          },
          "alert_threshold": {
            "type": "integer",
            "x-stoplight": {
              "id": "2kiaqy39ui93y"
            },
            "description": "The percentage of the budget to be reached in order to have a notification sent to the PMs"
          },
          "period_start": {
            "type": "string",
            "description": "Format: YYYY-MM-DD",
            "nullable": true
          },
          "period_end": {
            "type": "string",
            "description": "Format: YYYY-MM-DD",
            "nullable": true
          },
          "budget_percentage": {
            "type": "number",
            "minimum": 0,
            "description": "The percentage of completion of the budget"
          },
          "is_active": {
            "type": "integer",
            "minimum": 0,
            "maximum": 1,
            "description": "Whether or not the budget is active"
          }
        }
      },
      "Expense": {
        "type": "object",
        "x-examples": {
          "Example 1": {
            "description": "Paper clips",
            "date": "2025-03-13",
            "amount": "12",
            "calculated_amount": 12,
            "billable_status": "non-billable",
            "project_id": 356229,
            "user_id": 43,
            "expense_category_id": 3,
            "is_locked": 0,
            "account_id": 1,
            "unit_price": "1.00",
            "unit_name": null,
            "updated_at": "2025-03-13T08:37:58.000000Z",
            "created_at": "2025-03-13T08:37:58.000000Z",
            "expense_id": 3788
          }
        },
        "title": "Expense",
        "description": "An expense",
        "properties": {
          "expense_id": {
            "type": "integer",
            "description": "The expense unique identifier"
          },
          "description": {
            "type": "string",
            "description": "The description of the expense"
          },
          "date": {
            "type": "string",
            "description": "The date of the expense",
            "example": "2024-01-01"
          },
          "amount": {
            "type": "number",
            "format": "float",
            "description": "The amount of the expense. \nIf there is an expense category and it has a unit price, this value will be multiplied with the unit price to get the calculated_amount."
          },
          "calculated_amount": {
            "type": "number",
            "format": "float",
            "description": "The actual expense's amount. If there isn't an expense category or the category doesn't have a unit_price, it is equal to the amount."
          },
          "billable_status": {
            "description": "Tells if the expense's billable status:\nPossible values are: \"unbilled\", \"billed\", \"non-billable\", and \"billable\".",
            "enum": [
              "unbilled",
              "billed",
              "non-billable",
              "billable"
            ]
          },
          "project_id": {
            "type": "integer",
            "description": "The id of the project the expenses belongs to",
            "nullable": true
          },
          "user_id": {
            "type": "integer",
            "description": "The id of the user the expenses belongs to"
          },
          "expense_category_id": {
            "type": "integer",
            "description": "The id of the category the expenses belongs to",
            "nullable": true
          },
          "is_locked": {
            "type": "boolean",
            "description": "Tells if the expense is locked (the only reason can be by approval)"
          },
          "unit_price": {
            "type": "number",
            "format": "float",
            "default": 1,
            "description": "The unit price of the expense category (1 if none) redunded on the expense"
          },
          "unit_name": {
            "type": "string",
            "description": "The unit name of the expense category (null if none) redunded on the expense",
            "nullable": true
          },
          "updated_at": {
            "type": "string",
            "description": "The last update date"
          },
          "created_at": {
            "type": "string",
            "description": "The creation date"
          }
        }
      },
      "ExpenseCategory": {
        "type": "object",
        "x-stoplight": {
          "id": "80c93a41afff4"
        },
        "x-examples": {
          "Example 1": {
            "expense_category_id": 3,
            "account_id": 1,
            "name": "Entertainment",
            "color": "#F5C78E",
            "is_active": 1,
            "uses_unit_price": 0,
            "unit_name": null,
            "unit_price": "1.00",
            "created_at": "2023-09-07T09:52:05.000000Z",
            "updated_at": "2023-09-07T09:52:05.000000Z"
          }
        },
        "title": "ExpenseCategory",
        "description": "Used to categorize expenses",
        "nullable": true,
        "properties": {
          "expense_category_id": {
            "type": "integer",
            "description": "The expense category identifier"
          },
          "name": {
            "type": "string",
            "description": "The expense category name"
          },
          "color": {
            "type": "string",
            "description": "The expense category color (format #EF12AB)"
          },
          "is_active": {
            "type": "boolean",
            "description": "Indicates if the expense category is active or archived"
          },
          "uses_unit_price": {
            "type": "boolean",
            "description": "Tells if the expense category has a unit price.\nIf so, the expenses with this category uses unit_price as a multiplier to obtain the calculated amount"
          },
          "unit_name": {
            "type": "string",
            "description": "The name of the unit of the expenses, if any",
            "nullable": true
          },
          "unit_price": {
            "type": "number",
            "default": 1,
            "description": "The multiplier to the e",
            "format": "float"
          },
          "created_at": {
            "type": "string",
            "description": "The expense category creation date"
          },
          "updated_at": {
            "type": "string",
            "description": "The last update date"
          }
        }
      },
      "Client": {
        "title": "Client",
        "x-stoplight": {
          "id": "o6w3tpvmilemj"
        },
        "type": "object",
        "properties": {
          "client_id": {
            "type": "integer",
            "description": "Unique identifier"
          },
          "name": {
            "type": "string",
            "description": "Name of the client"
          },
          "is_active": {
            "type": "boolean",
            "description": "Whether or not the client is archived"
          },
          "color": {
            "type": "string",
            "pattern": "#[0-9A-F]{6}",
            "minLength": 7,
            "maxLength": 7,
            "description": "Color used in reports"
          }
        },
        "required": [
          "name"
        ],
        "description": "Represents a client of the company. A client can have multiple projects."
      },
      "Entry": {
        "type": "object",
        "x-examples": {},
        "title": "Entry",
        "description": "Represents a time entry in Lucen Track. Time entries are portions of time assigned to a project, a phase and optionally to a client (the one linked to the project) and multiple tags.",
        "x-stoplight": {
          "id": "5f8bbr1bf1gt7"
        },
        "x-internal": false,
        "properties": {
          "entry_id": {
            "type": "integer",
            "description": "Unique identifier"
          },
          "project_id": {
            "type": "integer",
            "description": "Unique identifier of the project"
          },
          "phase_id": {
            "type": "integer",
            "description": "Unique identifier of the the phase which the entry belongs to"
          },
          "phase_category_id": {
            "type": "integer",
            "description": "Unique identifier of the the phase category which the entry's phase belongs to"
          },
          "user_id": {
            "type": "integer",
            "description": "Unique identifier of the user that created the entry"
          },
          "client_id": {
            "type": "integer",
            "description": "Unique identifier of the client that belongs to the entry's project"
          },
          "entry_date": {
            "type": "string",
            "description": "Date of the entry",
            "example": "2023-01-01"
          },
          "entry_time_from": {
            "type": "string",
            "x-stoplight": {
              "id": "bnrhhcfdz7t98"
            },
            "description": "Start time for the entry",
            "pattern": "\\d{4}(.\\d{2}){2}(\\s|T)(\\d{2}.){2}\\d{2}",
            "deprecated": true,
            "nullable": true
          },
          "entry_time_to": {
            "type": "string",
            "x-stoplight": {
              "id": "33c8tz9ml60lg"
            },
            "description": "End time for the entry",
            "pattern": "\\d{4}(.\\d{2}){2}(\\s|T)(\\d{2}.){2}\\d{2}",
            "deprecated": true,
            "nullable": true
          },
          "created_date": {
            "type": "string",
            "example": "2023-01-01 10:00:00",
            "description": "Date and time of creation"
          },
          "updated_date": {
            "type": "string",
            "description": "Date and time od update"
          },
          "entry_minutes": {
            "type": "integer",
            "description": "Amount of tracked time in minutes"
          },
          "notes": {
            "type": "string",
            "description": "Notes on the time entry"
          },
          "billed": {
            "type": "integer",
            "description": "Indicates if the entry has been billed",
            "nullable": true
          },
          "source": {
            "type": "string",
            "description": "Indicates the source of the entry (if any)"
          },
          "source_text": {
            "type": "string",
            "description": "A text that describes the source of the entry"
          },
          "source_url": {
            "type": "string",
            "description": "An URL to the source of the entry"
          },
          "source_id": {
            "type": "string",
            "description": "A unique identifier of the source of the entry"
          },
          "source_data": {
            "type": "string",
            "description": "Additional data of the source "
          },
          "locked": {
            "type": "integer",
            "description": "Whether or not the entry is locked"
          },
          "locked_by_date": {
            "type": "integer",
            "description": "Whether or not the entry is locked by date"
          },
          "locked_by_membership": {
            "type": "integer",
            "description": "Whether or not the entry is locked by membership"
          },
          "locked_by_apionly": {
            "type": "integer",
            "description": "Whether or not the entry is locked by restriction on API only"
          },
          "suggested_project_id": {
            "type": "string",
            "description": "An optional identifier of a suggested project if the entry is created from an EntrySuggestion",
            "nullable": true
          },
          "suggested_phase_id": {
            "type": "string",
            "description": "An optional identifier of a suggested phase if the entry is created from an EntrySuggestion",
            "nullable": true
          },
          "cost": {
            "type": "string",
            "description": "The monetary cost of the time entry based on the hourly cost of the user that created it",
            "nullable": true
          },
          "revenue": {
            "type": "string",
            "description": "The monetary revenue of the time entry based on the general hourly rate,the project's .",
            "nullable": true
          },
          "profit": {
            "type": "string",
            "description": "The difference between the revenue and the cost",
            "nullable": true
          },
          "todo_id": {
            "type": "string",
            "description": "The unique identifier of a todo linked to the time entry",
            "nullable": true
          },
          "time_from": {
            "type": "string",
            "x-stoplight": {
              "id": "wf9ymonsk0ieg"
            },
            "description": "Start time for the entry",
            "pattern": "\\d{4}(.\\d{2}){2}(\\s|T)(\\d{2}.){2}\\d{2}",
            "nullable": true
          },
          "time_to": {
            "type": "string",
            "x-stoplight": {
              "id": "ss6r1v1tc90vp"
            },
            "description": "End time for the entry",
            "pattern": "\\d{4}(.\\d{2}){2}(\\s|T)(\\d{2}.){2}\\d{2}",
            "nullable": true
          },
          "tag_ids": {
            "type": "array",
            "x-stoplight": {
              "id": "337vfnsjmk93c"
            },
            "description": "The IDs of the tags attached to the entry",
            "items": {
              "x-stoplight": {
                "id": "1q0zkbmav7bye"
              },
              "type": "integer"
            }
          }
        }
      },
      "Timer": {
        "type": "object",
        "x-examples": {},
        "title": "Timer",
        "description": "a Lucen Track timer",
        "x-stoplight": {
          "id": "nog9f972tdw3t"
        },
        "required": [
          "project_id",
          "phase_id",
          "user_id",
          "seconds"
        ],
        "properties": {
          "timer_id": {
            "type": "integer",
            "description": "Unique identifier of the timer"
          },
          "project_id": {
            "type": "integer",
            "description": "Unique identifier of the project"
          },
          "phase_id": {
            "type": "integer",
            "description": "phase id"
          },
          "user_id": {
            "type": "integer",
            "description": "Unique identifier of the user that c"
          },
          "timer_start": {
            "type": "string",
            "example": "2023-01-01 10:00:00",
            "deprecated": true
          },
          "time_from": {
            "type": "string",
            "x-stoplight": {
              "id": "wf9ymonsk0ieg"
            },
            "description": "Start time for the timer",
            "pattern": "\\d{4}(.\\d{2}){2}(\\s|T)(\\d{2}.){2}\\d{2}"
          },
          "timer_status": {
            "type": "string",
            "enum": [
              "running",
              "paused"
            ]
          },
          "seconds": {
            "type": "integer",
            "minimum": 0,
            "exclusiveMinimum": false
          },
          "notes": {
            "type": "string",
            "description": "Notes on the time entry"
          },
          "source": {
            "type": "string",
            "description": "Indicates the source of the entry (if any)"
          },
          "source_text": {
            "type": "string",
            "description": "A text that describes the source of the entry"
          },
          "source_url": {
            "type": "string",
            "description": "An URL to the source of the entry"
          },
          "source_id": {
            "type": "string",
            "description": "A unique identifier of the source of the entry"
          },
          "source_data": {
            "type": "string",
            "description": "Additional data of the source"
          },
          "timer_date": {
            "type": "string",
            "example": "2023-01-01",
            "description": "The data in which the timer has been started"
          },
          "todo_id": {
            "type": "integer",
            "nullable": true
          }
        }
      },
      "User": {
        "type": "object",
        "x-examples": {},
        "title": "User",
        "description": "User",
        "properties": {
          "user_id": {
            "type": "integer",
            "description": "Unique identifier of the user"
          },
          "group_id": {
            "type": "integer",
            "description": "Unique identifier of the group to which the user belongs to"
          },
          "email": {
            "type": "string",
            "description": "Email of the user, must be unique"
          },
          "first_name": {
            "type": "string",
            "description": "First name of the user"
          },
          "last_name": {
            "type": "string",
            "description": "Last name of the user"
          },
          "name": {
            "type": "string",
            "description": "Name of the user"
          },
          "enabled": {
            "type": "integer",
            "description": "Tells if the user is archived or not"
          },
          "created_date": {
            "type": "string",
            "description": "Date of creation of the user"
          },
          "is_owner": {
            "type": "boolean",
            "description": "Whether or not the user is an owner of the account"
          },
          "is_admin": {
            "type": "boolean",
            "description": "Whether or not the user is an admin of the account"
          },
          "is_gm": {
            "type": "boolean",
            "description": "Whether or not the user is a group manager of his group"
          },
          "settings_dailyemail_time": {
            "type": "integer",
            "description": "Hour of the day in which the user receives the daily email"
          },
          "settings_emails_newsletter_enabled": {
            "type": "integer",
            "description": "Whether or not the newsletter emails are enabled fro the user"
          },
          "settings_emails_system_enabled": {
            "type": "integer",
            "description": "Whether or not the system emails are enabled fro the user"
          },
          "settings_emails_developer_enabled": {
            "type": "integer",
            "description": "Whether or not the emails regarding developer updates are enabled fro the user"
          },
          "settings_emails_dailyrecap_enabled": {
            "type": "integer",
            "description": "Whether or not the daily recap email is enabled fro the user"
          },
          "settings_emails_timerssaved_enabled": {
            "type": "integer",
            "description": "Whether or not the email containing the unsaved timers is enabled fro the user"
          },
          "settings_emails_status_enabled": {
            "type": "integer",
            "description": "Whether or not the email containing the status update is enabled fro the user"
          },
          "settings_emails_status_time": {
            "type": "integer",
            "description": "Hour of the day in which the user receives the status email"
          },
          "settings_emails_status_day": {
            "type": "integer",
            "description": "Day of the week in which the user receives the status email"
          },
          "settings_emails_onboarding_enabled": {
            "type": "integer",
            "description": "Whether or not the emails to guide the user through the trial period are enabled"
          },
          "settings_emails_automation_enabled": {
            "type": "integer",
            "description": "Enable this option to be able to receive the e-mails from the automations, and be able to create automations regarding scheduled reports."
          },
          "user_hourly_cost": {
            "type": "string",
            "description": "The hourly cost of the user, expressed in the currency selected in the account settings"
          },
          "user_hourly_rate": {
            "type": "string",
            "description": "The hourly rate of the user, expressed in the currency selected in the account settings"
          },
          "role": {
            "type": "string",
            "nullable": true,
            "description": "The role of the user in the company."
          },
          "job_title": {
            "type": "string",
            "description": "The job title of the user in the company"
          },
          "department": {
            "type": "string",
            "nullable": true,
            "description": "The user's department"
          },
          "employee_id": {
            "type": "string",
            "nullable": true,
            "description": "The employee ID of the user"
          },
          "working_time": {
            "type": "integer",
            "description": "How many hours the user is usually working on a day"
          },
          "microsoft_id": {
            "type": "string",
            "description": "Microsoft unique identifier of the user"
          },
          "google_id": {
            "type": "string",
            "description": "Google unique identifier of the user"
          },
          "apple_id": {
            "type": "string",
            "description": "Apple unique identifier of the user"
          },
          "workspace_access_level": {
            "type": "string",
            "description": "The role of the user in Lucen Track: owner, admin or member"
          }
        },
        "x-stoplight": {
          "id": "8r0gf5rqoxwwv"
        }
      },
      "Project": {
        "type": "object",
        "x-examples": {},
        "title": "Project",
        "description": "A project the principal way of categorizing the time in Lucen Track.\nProjects have one or more tasks on which the time is spent.",
        "x-stoplight": {
          "id": "aa7t79mq3m8d2"
        },
        "required": [
          "name"
        ],
        "properties": {
          "project_id": {
            "type": "integer",
            "description": "Unique identifier"
          },
          "name": {
            "type": "string",
            "description": "The project's name"
          },
          "client_id": {
            "type": "integer",
            "description": "Unique identifier of a client that the project belongs to"
          },
          "is_active": {
            "type": "integer",
            "description": "Whether or not the project is archived"
          },
          "is_billable": {
            "type": "integer",
            "description": "Whether or not the project is billable per hour"
          },
          "is_public": {
            "type": "integer",
            "description": "Whether or not the project is public, meaning that it is visible by all the users in the workspace and everybody can track time on it"
          },
          "hourly_rate": {
            "type": "string",
            "description": "The general hourly rate for the project. A specific hourly_rate can be set on the project-user relation"
          },
          "color": {
            "type": "string",
            "description": "The color used for reporting"
          },
          "api_only": {
            "type": "integer",
            "description": "Whether or not the project is usable for tracking time only using the apis."
          },
          "description": {
            "type": "string",
            "description": "A text description of the project"
          },
          "has_todos": {
            "type": "boolean",
            "x-stoplight": {
              "id": "l9k5d3pk8f9cv"
            },
            "description": "Tells if the project has the Tasks section enabled"
          }
        }
      },
      "Phase": {
        "type": "object",
        "x-examples": {},
        "title": "Phase",
        "description": "A project's phase",
        "x-stoplight": {
          "id": "2gsuxkayxq83f"
        },
        "properties": {
          "phase_id": {
            "type": "integer",
            "description": "Unique identifier"
          },
          "project_id": {
            "type": "integer",
            "description": "Unique identifier of the project which the phase belongs to"
          },
          "name": {
            "type": "string",
            "description": "The name of the phase"
          },
          "is_open": {
            "type": "integer",
            "description": "Whether or not the phase is archived"
          },
          "phase_category_id": {
            "type": "integer",
            "description": "Unique identifier of the phase category which the phase belongs to"
          },
          "budget_minutes": {
            "type": "integer",
            "description": "Amount of budgeted time for theis phase. The sum of the budget_minutes of the phases must not be grater than the budgeted time for the project"
          }
        },
        "required": [
          "project_id",
          "name"
        ]
      },
      "TagList": {
        "type": "object",
        "x-examples": {},
        "properties": {
          "tag_list_id": {
            "type": "integer",
            "description": "Unique identifier"
          },
          "name": {
            "type": "string",
            "description": "The name of the tag list"
          },
          "is_active": {
            "type": "integer",
            "description": "Whether or not the tag list is archived"
          },
          "color": {
            "type": "string",
            "description": "The color used for reporting"
          },
          "text_color": {
            "type": "string",
            "description": "The color of the text used for reporting"
          }
        },
        "required": [
          "name",
          "color",
          "text_color"
        ],
        "x-stoplight": {
          "id": "z8r3lwt40nihp"
        }
      },
      "Tag": {
        "type": "object",
        "x-examples": {},
        "description": "A tag",
        "title": "Tag",
        "properties": {
          "tag_id": {
            "type": "integer",
            "description": "Unique identifier"
          },
          "tag_list_id": {
            "type": "integer",
            "description": "Unique identifier of the tag list which the tag belongs to"
          },
          "name": {
            "type": "string",
            "description": "The name of the tag"
          },
          "is_active": {
            "type": "integer",
            "description": "Whether or not the tag is archived"
          },
          "color": {
            "type": "string",
            "description": "The color used for reporting"
          }
        },
        "required": [
          "tag_list_id",
          "name"
        ],
        "x-stoplight": {
          "id": "iwk9zguiajgif"
        }
      },
      "EntrySuggestion": {
        "type": "object",
        "x-examples": {},
        "properties": {
          "entry_suggestion_id": {
            "type": "integer",
            "description": "Unique identifier"
          },
          "created_datetime": {
            "type": "string",
            "description": "Date and time of creation of the suggestion"
          },
          "user_id": {
            "type": "integer",
            "description": "Unique identifier of the user that owns the suggestion"
          },
          "project_id": {
            "type": "integer",
            "description": "Unique identifier of the suggested project"
          },
          "project_name": {
            "type": "string",
            "description": "Name of the suggested project"
          },
          "phase_id": {
            "type": "integer",
            "description": "Unique identifier of the suggested phase"
          },
          "phase_name": {
            "type": "string",
            "description": "Name of the suggested phase"
          },
          "notes": {
            "type": "string",
            "description": "Notes related to the source of the suggestion"
          },
          "source": {
            "type": "string",
            "description": "Source identifier"
          },
          "source_text": {
            "type": "string",
            "description": "Text related to the source"
          },
          "source_url": {
            "type": "string",
            "description": "URL of the source of the suggestion"
          },
          "source_id": {
            "type": "string",
            "description": "Unique identifier of the source"
          },
          "source_data": {
            "type": "string",
            "description": "Other data related to the source"
          },
          "entry_minutes": {
            "type": "integer",
            "description": "Suggested amount of time in minutes"
          },
          "entry_date": {
            "type": "string",
            "description": "Suggested date"
          },
          "accepted": {
            "type": "integer",
            "description": "Whether or not the suggestion is accepted an transformed into an entry"
          },
          "todo_id": {
            "type": "integer",
            "nullable": true
          }
        },
        "x-stoplight": {
          "id": "rczv4ar2ph4q2"
        }
      },
      "Group": {
        "type": "object",
        "x-examples": {},
        "title": "Group",
        "description": "A group of users",
        "properties": {
          "group_id": {
            "type": "integer",
            "description": "Unique identifier"
          },
          "name": {
            "type": "string",
            "description": "Name of the group"
          },
          "color": {
            "type": "string",
            "description": "The color used for reporting"
          }
        },
        "x-stoplight": {
          "id": "gh9aq1pihfeit"
        }
      },
      "Language": {
        "type": "object",
        "properties": {
          "language_code": {
            "type": "string",
            "description": "Unique identifier"
          },
          "name": {
            "type": "string",
            "description": "Name of the language"
          }
        },
        "x-examples": {},
        "title": "Language",
        "description": "A language supported in Lucen Track",
        "x-stoplight": {
          "id": "ri5snko16593b"
        }
      },
      "PhaseCategory": {
        "type": "object",
        "x-examples": {},
        "title": "PhaseCategory",
        "description": "Categorizes phases",
        "x-stoplight": {
          "id": "1b463g7kp1qsa"
        },
        "nullable": true,
        "properties": {
          "phase_category_id": {
            "type": "integer",
            "description": "Unique identifier"
          },
          "name": {
            "type": "string",
            "description": "Name of the phase category"
          },
          "color": {
            "type": "string",
            "description": "The color used for reporting"
          }
        }
      },
      "Todo": {
        "title": "Todo",
        "x-stoplight": {
          "id": "weym60vlwuhf7"
        },
        "type": "object",
        "description": "It is a todo in Lucen Track",
        "properties": {
          "todo_id": {
            "type": "integer",
            "description": "Unique identifier"
          },
          "todo_list_id": {
            "type": "integer",
            "description": "Unique identifier of the todo list which the todo belongs to",
            "nullable": true
          },
          "user_id": {
            "type": "integer",
            "description": "Unique identifier of the user assigned to the todo",
            "nullable": true
          },
          "name": {
            "type": "string",
            "description": "Title of the todo"
          },
          "description": {
            "type": "string",
            "description": "Description of the todo"
          },
          "is_completed": {
            "type": "boolean",
            "description": "Whether or not the todo is marked as done"
          },
          "priority": {
            "type": "string",
            "description": "Priority of the todo"
          },
          "start_date": {
            "type": "string",
            "example": "2023-01-01",
            "description": "The date in which the todo should be taken in charge",
            "nullable": true
          },
          "due_date": {
            "type": "string",
            "example": "2023-01-01",
            "description": "The data by which the todo should be completed",
            "nullable": true
          },
          "status": {
            "type": "string",
            "description": "The current status of the todo"
          },
          "index": {
            "type": "integer",
            "description": "The index of the todo in the list (order)"
          },
          "created_at": {
            "type": "string",
            "example": "2023-01-01 10:00:00",
            "description": "Created date and time"
          },
          "updated_at": {
            "type": "string",
            "example": "2023-01-01 10:00:00",
            "description": "Updated date and time"
          }
        }
      },
      "TodoList": {
        "title": "TodoList",
        "x-stoplight": {
          "id": "1363raammdbed"
        },
        "type": "object",
        "properties": {
          "todo_list_id": {
            "type": "integer",
            "description": "Unique identifier"
          },
          "project_id": {
            "type": "integer",
            "description": "Unique identifier of the project which the todo list belongs to"
          },
          "name": {
            "type": "string",
            "description": "Name of the todo list"
          },
          "color": {
            "type": "string",
            "description": "The color used for reporting"
          },
          "index": {
            "type": "integer",
            "description": "The index of the todo list in the board (order)"
          },
          "created_at": {
            "type": "string",
            "description": "Created date and time"
          },
          "updated_at": {
            "type": "string",
            "description": "Updated date and time"
          }
        }
      },
      "Zone": {
        "type": "object",
        "properties": {
          "zone_id": {
            "type": "integer",
            "description": "Unique identifier"
          },
          "country_code": {
            "type": "string",
            "description": "Code of the country which the zone belongs to"
          },
          "name": {
            "type": "string",
            "description": "Name of the time zone"
          }
        },
        "x-examples": {},
        "title": "Zone",
        "description": "A timezone object",
        "x-stoplight": {
          "id": "srt2ge5xz5dn1"
        }
      },
      "Attachment": {
        "type": "object",
        "x-examples": {
          "Example 1": {
            "attachment_id": 973,
            "account_id": 1,
            "attachable_type": "expense",
            "attachable_id": 3788,
            "original_name": "Impegno comune logo.png",
            "extension": "png",
            "size_in_bytes": 29384,
            "created_at": "2025-03-13T09:41:54.000000Z",
            "updated_at": "2025-03-13T09:41:54.000000Z"
          }
        },
        "title": "Attachment",
        "description": "A file uploaded to Lucen Track",
        "properties": {
          "attachment_id": {
            "type": "integer",
            "description": "the Attachment unique identifier"
          },
          "attachable_type": {
            "type": "string",
            "description": "The identifier of the model the attachment is attached to "
          },
          "attachable_id": {
            "type": "integer",
            "description": "The name of the model the attachment is attached to"
          },
          "original_name": {
            "type": "string",
            "description": "The original name of the file"
          },
          "extension": {
            "type": "string",
            "description": "The extension of the file"
          },
          "size_in_bytes": {
            "type": "integer",
            "description": "The size in bytes of the file"
          },
          "created_at": {
            "type": "string",
            "description": "The creation date"
          },
          "updated_at": {
            "type": "string",
            "description": "The last update date"
          }
        }
      },
      "ApprovalEvent": {
        "type": "object",
        "x-examples": {
          "Example 1": {
            "approval_event_id": 11991,
            "approval_request_id": 3123,
            "user_id": null,
            "event_datetime": "2025-03-04 00:01:26",
            "event_type": "submission",
            "user_name": "Automation",
            "event_notes": "This approval request was submitted automatically.",
            "created_at": "2025-03-04 00:01:26",
            "updated_at": "2025-03-04 00:01:26"
          }
        },
        "title": "ApprovalEvent",
        "description": "An event that occurs during an approval request lifecycle",
        "properties": {
          "approval_event_id": {
            "type": "integer",
            "description": "The unique identifier of the approval event"
          },
          "approval_request_id": {
            "type": "integer",
            "description": "The unique identifier of the approval request to which the event belongs to"
          },
          "user_id": {
            "description": "The unique identifier of the user to which the event belongs to.\nNull if the event was generated automatically.",
            "type": "integer",
            "nullable": true
          },
          "event_datetime": {
            "type": "string",
            "description": "The date and time in which the event occurred (UTC)"
          },
          "event_type": {
            "description": "This is an enumeration representing the possible types associated to an approval event.",
            "enum": [
              "submission",
              "approval",
              "rejection",
              "withdrawal"
            ]
          },
          "user_name": {
            "type": "string",
            "description": "The name of the user to which the envent belongs to"
          },
          "event_notes": {
            "type": "string",
            "description": "The notes related to the event"
          },
          "created_at": {
            "type": "string",
            "description": "The event creation date (UTC)"
          },
          "updated_at": {
            "type": "string",
            "description": "The event last update date (UTC)"
          }
        }
      },
      "ApprovalRequest": {
        "type": "object",
        "x-examples": {
          "Example 1": {
            "approval_request_id": 3123,
            "user_id": 43,
            "date_from": "2025-02-24",
            "date_to": "2025-03-02",
            "created_at": "2025-03-04 00:01:26",
            "updated_at": "2025-03-04 00:01:26",
            "status": "pending_approval",
            "total_time": 669,
            "total_expenses": null
          }
        },
        "properties": {
          "approval_request_id": {
            "type": "integer",
            "description": "The unique identifier of the approval request"
          },
          "user_id": {
            "type": "integer",
            "description": "The unique identifier of the user who created the approval request"
          },
          "date_from": {
            "type": "string",
            "description": "The start date of the approval request period"
          },
          "date_to": {
            "type": "string",
            "description": "The end date of the approval request period"
          },
          "created_at": {
            "type": "string",
            "description": "The date and time when the approval request was created"
          },
          "updated_at": {
            "type": "string",
            "description": "The date and time when the approval request was last updated"
          },
          "status": {
            "enum": [
              "pending_approval",
              "approved",
              "rejected",
              "unsubmitted"
            ],
            "description": "The current status of the approval request"
          },
          "total_time": {
            "type": "integer",
            "nullable": true,
            "description": "The total time in minutes included in this approval request"
          },
          "total_expenses": {
            "type": "number",
            "format": "float",
            "nullable": true,
            "description": "The total amount of expenses included in this approval request"
          }
        },
        "title": "ApprovalRequest"
      },
      "FeatureFlag": {
        "title": "FeatureFlag",
        "x-stoplight": {
          "id": "hybb9nvjwh0l4"
        },
        "type": "object",
        "properties": {
          "key": {
            "type": "string",
            "x-stoplight": {
              "id": "ec14ws1s09ako"
            }
          },
          "value": {
            "type": "string",
            "x-stoplight": {
              "id": "4zzzq5fxp6ft7"
            }
          },
          "enabled": {
            "type": "boolean",
            "x-stoplight": {
              "id": "jfd7zgea0dowu"
            }
          }
        },
        "description": "A feature flag for internal development and release",
        "x-internal": true
      }
    }
  },
  "paths": {
    "/account": {
      "parameters": [],
      "put": {
        "tags": [
          "Accounts"
        ],
        "summary": "Update Account",
        "operationId": "put-account-account_id",
        "description": "Updates an account",
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "allOf": [
                    {
                      "$ref": "#/components/schemas/Account"
                    },
                    {
                      "type": "object",
                      "properties": {
                        "avatar": {
                          "$ref": "#/components/schemas/Avatar"
                        }
                      }
                    }
                  ]
                }
              }
            }
          },
          "403": {
            "$ref": "#/components/responses/403"
          }
        },
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "x-examples": {},
                "properties": {
                  "account_name": {
                    "type": "string",
                    "description": "The name of the account, usually the Company name."
                  },
                  "settings": {
                    "type": "object",
                    "properties": {
                      "entries_lock_automation": {
                        "type": "object",
                        "description": "Describes the automatic entry lock parameters",
                        "nullable": true,
                        "properties": {
                          "enabled": {
                            "type": "boolean",
                            "description": "Whether or not the entry lock automation is enabled\n\n"
                          },
                          "interval": {
                            "type": "string",
                            "description": "Interval of the entry lock\n\n",
                            "nullable": true
                          },
                          "interval_target": {
                            "type": "number",
                            "description": "Between 1 and 31 if the interval is monthly (the day of the month), Between 0 and 6i if the interval is weekly\n\n",
                            "nullable": true
                          }
                        }
                      },
                      "currencyCode": {
                        "type": "string",
                        "description": "Code of the used currency"
                      },
                      "adminNewEntryForOthers": {
                        "type": "boolean",
                        "description": "Possibility to add entries on behalf of other users"
                      },
                      "register_time_for_others_roles": {
                        "type": "array",
                        "description": "Roles that are allowed to register time on behalf of other users. Requires the add_time_for_other_users feature to be enabled.",
                        "items": {
                          "type": "string",
                          "enum": [
                            "owner",
                            "admin",
                            "gm",
                            "pm",
                            "all_managers"
                          ]
                        }
                      },
                      "showWorkingTime": {
                        "type": "boolean",
                        "description": "Whether or not the users can see their working time in their dashboard. (e.g. 7h of 8h)\n\n"
                      },
                      "memberAverageCost": {
                        "type": "number",
                        "description": "Indicates the average labour cost for the account members\n\n"
                      },
                      "authenticationMethod": {
                        "type": "object",
                        "properties": {
                          "type": {
                            "type": "string",
                            "description": "Type of login method\n\n"
                          },
                          "idp_metadata_url": {
                            "type": "string",
                            "description": "Id of the identity provider (used with type = saml)\n\n"
                          },
                          "idp_entity_id": {
                            "type": "string",
                            "description": "Id of the identity provider (used with type = saml)\n\n"
                          },
                          "idp_sso_url": {
                            "type": "string",
                            "description": "Single Sign on URL (used with type = saml)\n\n"
                          },
                          "idp_cert": {
                            "type": "string",
                            "description": "Certificate of the identity provider (used with type = saml)\n\n"
                          },
                          "allow_password_login": {
                            "type": "boolean",
                            "description": "Whether or not the login with email + password is allowed\n\n"
                          }
                        }
                      },
                      "required_fields": {
                        "type": "array",
                        "x-stoplight": {
                          "id": "i3r9su7mpw2tz"
                        },
                        "description": "An array representing the required fields.\nAllowed values are entry_notes, to require entries to have notes, and expense_project, to require expenses to have a project.",
                        "items": {
                          "x-stoplight": {
                            "id": "um79kws0ji8ys"
                          },
                          "enum": [
                            "entry_notes",
                            "expense_project"
                          ]
                        }
                      },
                      "allow_apps": {
                        "type": "integer",
                        "x-stoplight": {
                          "id": "a7nle4q06frx2"
                        },
                        "minimum": 0,
                        "maximum": 1,
                        "exclusiveMinimum": false,
                        "exclusiveMaximum": false
                      }
                    }
                  }
                }
              }
            }
          },
          "description": "Account request"
        },
        "parameters": [
          {
            "schema": {
              "type": "string"
            },
            "in": "header",
            "name": "Accept",
            "description": "application/json"
          }
        ]
      },
      "get": {
        "summary": "Get Account",
        "operationId": "get-account",
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "allOf": [
                    {
                      "$ref": "#/components/schemas/Account"
                    },
                    {
                      "type": "object",
                      "properties": {
                        "avatar": {
                          "$ref": "#/components/schemas/Avatar"
                        }
                      }
                    }
                  ]
                }
              }
            }
          },
          "401": {
            "$ref": "#/components/responses/401"
          }
        },
        "description": "Gets the information on the user account",
        "parameters": [
          {
            "schema": {
              "type": "string"
            },
            "in": "header",
            "name": "Accept",
            "description": "application/json"
          }
        ],
        "tags": [
          "Accounts"
        ]
      }
    },
    "/avatars": {
      "post": {
        "tags": [
          "Avatars"
        ],
        "summary": "Create an Avatar",
        "operationId": "post-avatar-avatar_id",
        "description": "Creates an avatar",
        "requestBody": {
          "content": {
            "multipart/form-data": {
              "schema": {
                "type": "object",
                "properties": {
                  "image": {
                    "type": "string",
                    "description": "A file containing an image",
                    "format": "binary"
                  },
                  "user_id": {
                    "type": "integer",
                    "description": "Identifier of the user which has this avatar",
                    "nullable": true
                  },
                  "account_id": {
                    "type": "integer",
                    "description": "Identifier of the account which has this avatar",
                    "nullable": true
                  }
                },
                "required": [
                  "image"
                ]
              }
            }
          },
          "description": ""
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Avatar"
                }
              }
            }
          },
          "422": {
            "$ref": "#/components/responses/422"
          }
        },
        "parameters": [
          {
            "schema": {
              "type": "string"
            },
            "in": "header",
            "name": "Accept",
            "description": "application/json"
          }
        ],
        "x-internal": true
      },
      "parameters": []
    },
    "/budgets": {
      "get": {
        "tags": [
          "Budgets"
        ],
        "operationId": "listBudgets",
        "description": "Get budgets list",
        "parameters": [
          {
            "$ref": "#/components/parameters/page"
          },
          {
            "$ref": "#/components/parameters/per_page"
          },
          {
            "$ref": "#/components/parameters/sort_by"
          },
          {
            "$ref": "#/components/parameters/direction"
          },
          {
            "schema": {
              "type": "integer"
            },
            "in": "query",
            "name": "project_id",
            "description": "Identifier of the project to which the budget belongs"
          },
          {
            "schema": {
              "type": "string"
            },
            "in": "header",
            "name": "Accept",
            "description": "application/json"
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "x-examples": {
                    "Example 1": {
                      "data": [
                        {
                          "budget_id": 1,
                          "project_id": 2,
                          "recurrence": 0,
                          "interval": -1,
                          "budget_minutes": 540,
                          "is_active": 1,
                          "period_start": null,
                          "period_end": null
                        },
                        {
                          "budget_id": 2,
                          "project_id": 3,
                          "recurrence": 0,
                          "interval": -1,
                          "budget_minutes": 1020,
                          "is_active": 1,
                          "period_start": null,
                          "period_end": null
                        }
                      ],
                      "links": {
                        "first": "https://track-api.lucensoftware.com/api/v1/budgets?page=1",
                        "last": "https://track-api.lucensoftware.com/api/v1/budgets?page=1",
                        "prev": null,
                        "next": null
                      },
                      "meta": {
                        "current_page": 1,
                        "from": 1,
                        "last_page": 1,
                        "links": [
                          {
                            "url": null,
                            "label": "&laquo; Previous",
                            "active": false
                          },
                          {
                            "url": "https://track-api.lucensoftware.com/api/v1/budgets?page=1",
                            "label": "1",
                            "active": true
                          },
                          {
                            "url": null,
                            "label": "Next &raquo;",
                            "active": false
                          }
                        ],
                        "path": "https://track-api.lucensoftware.com/api/v1/budgets",
                        "per_page": 200,
                        "to": 126,
                        "total": 126
                      }
                    }
                  },
                  "properties": {
                    "data": {
                      "type": "array",
                      "items": {
                        "$ref": "#/components/schemas/Budget"
                      }
                    },
                    "links": {
                      "type": "object",
                      "properties": {
                        "first": {
                          "type": "string"
                        },
                        "last": {
                          "type": "string"
                        },
                        "prev": {
                          "type": "string",
                          "nullable": true
                        },
                        "next": {
                          "type": "string",
                          "nullable": true
                        }
                      }
                    },
                    "meta": {
                      "type": "object",
                      "properties": {
                        "current_page": {
                          "type": "integer"
                        },
                        "from": {
                          "type": "integer"
                        },
                        "last_page": {
                          "type": "integer"
                        },
                        "links": {
                          "type": "array",
                          "items": {
                            "type": "object",
                            "properties": {
                              "url": {
                                "type": "string",
                                "nullable": true
                              },
                              "label": {
                                "type": "string"
                              },
                              "active": {
                                "type": "boolean"
                              }
                            }
                          }
                        },
                        "path": {
                          "type": "string"
                        },
                        "per_page": {
                          "type": "integer"
                        },
                        "to": {
                          "type": "integer"
                        },
                        "total": {
                          "type": "integer"
                        }
                      }
                    }
                  }
                },
                "examples": {
                  "example-1": {
                    "value": {
                      "data": [
                        {
                          "budget_id": 0,
                          "project_id": 0,
                          "recurrence": 0,
                          "interval": 0,
                          "budget_minutes": 0,
                          "is_active": 0,
                          "period_start": "string",
                          "period_end": "string"
                        }
                      ],
                      "links": {
                        "first": "https://track-api.lucensoftware.com/api/v1/budgets?page=1",
                        "last": "https://track-api.lucensoftware.com/api/v1/budgets?page=1",
                        "prev": null,
                        "next": null
                      },
                      "meta": {
                        "current_page": 1,
                        "from": 1,
                        "last_page": 1,
                        "links": [
                          {
                            "url": null,
                            "label": "&laquo; Previous",
                            "active": false
                          },
                          {
                            "url": "https://track-api.lucensoftware.com/api/v1/budgets?page=1",
                            "label": "1",
                            "active": true
                          },
                          {
                            "url": null,
                            "label": "Next &raquo;",
                            "active": false
                          }
                        ],
                        "path": "https://track-api.lucensoftware.com/api/v1/budgets",
                        "per_page": 200,
                        "to": 126,
                        "total": 126
                      }
                    }
                  }
                }
              }
            }
          },
          "422": {
            "$ref": "#/components/responses/422"
          }
        },
        "x-internal": true,
        "summary": "List Budgets"
      },
      "post": {
        "tags": [
          "Budgets"
        ],
        "summary": "Create a Budget",
        "operationId": "post-budget",
        "description": "Creates a budget",
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "properties": {
                  "project_id": {
                    "type": "integer",
                    "description": "Identifier of the project to which the budget belongs"
                  },
                  "recurrence": {
                    "type": "integer",
                    "enum": [
                      1,
                      2,
                      3
                    ],
                    "description": "Recurrence of the budget: 0 = no recurrence, 1 = weekly, 2 = monthly"
                  },
                  "interval": {
                    "type": "integer",
                    "description": "Recurrence of the budget: 0 = no recurrence, 1 = weekly, 2 = monthly",
                    "nullable": true
                  },
                  "budget_minutes": {
                    "type": "integer",
                    "description": "The amount of minutes the budget represents"
                  }
                },
                "required": [
                  "project_id",
                  "recurrence",
                  "budget_minutes"
                ]
              }
            }
          },
          "description": ""
        },
        "responses": {
          "201": {
            "description": "Created",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Budget"
                }
              }
            }
          },
          "403": {
            "$ref": "#/components/responses/403"
          },
          "422": {
            "$ref": "#/components/responses/422"
          }
        },
        "parameters": [
          {
            "schema": {
              "type": "string"
            },
            "in": "header",
            "name": "Accept",
            "description": "application/json"
          }
        ]
      }
    },
    "/budgets/{budget}": {
      "get": {
        "tags": [
          "Budgets"
        ],
        "operationId": "get-budget-budget_id",
        "description": "Get a budget",
        "parameters": [
          {
            "schema": {
              "type": "string"
            },
            "in": "header",
            "name": "Accept",
            "description": "application/json"
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Budget"
                }
              }
            }
          },
          "403": {
            "$ref": "#/components/responses/403"
          },
          "404": {
            "$ref": "#/components/responses/404"
          }
        },
        "summary": "Get a Budget"
      },
      "parameters": [
        {
          "schema": {
            "type": "string"
          },
          "name": "budget",
          "description": "budget",
          "in": "path",
          "required": true
        }
      ],
      "put": {
        "summary": "Update a Budget",
        "operationId": "put-budget-budget_id",
        "description": "Updates a budget",
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Budget"
                }
              }
            }
          },
          "403": {
            "$ref": "#/components/responses/403"
          },
          "404": {
            "$ref": "#/components/responses/404"
          },
          "422": {
            "$ref": "#/components/responses/422"
          }
        },
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "x-examples": {},
                "properties": {
                  "recurrence": {
                    "type": "integer",
                    "description": "Recurrence of the budget: 0 = no recurrence, 1 = weekly, 2 = monthly"
                  },
                  "interval": {
                    "type": "integer",
                    "description": "Day of budget reset: 1 to 31 if the budget is monthly, 0 to 6 if the budget is weekly"
                  },
                  "budget_minutes": {
                    "type": "integer",
                    "description": "Day of budget reset: 1 to 31 if the budget is monthly, 0 to 6 if the budget is weekly"
                  }
                }
              }
            }
          },
          "description": ""
        },
        "parameters": [
          {
            "schema": {
              "type": "string"
            },
            "in": "header",
            "name": "Accept",
            "description": "application/json"
          }
        ],
        "tags": [
          "Budgets"
        ]
      },
      "delete": {
        "summary": "Delete a Budget",
        "operationId": "delete-budget-budget_id",
        "responses": {
          "200": {
            "description": "OK"
          },
          "403": {
            "$ref": "#/components/responses/403"
          },
          "404": {
            "$ref": "#/components/responses/404"
          }
        },
        "description": "Deletes a budget",
        "parameters": [
          {
            "schema": {
              "type": "string"
            },
            "in": "header",
            "name": "Accept",
            "description": "application/json"
          }
        ],
        "tags": [
          "Budgets"
        ]
      }
    },
    "/clients": {
      "get": {
        "tags": [
          "Clients"
        ],
        "operationId": "list-clients",
        "description": "Get clients list",
        "parameters": [
          {
            "$ref": "#/components/parameters/page"
          },
          {
            "$ref": "#/components/parameters/per_page"
          },
          {
            "$ref": "#/components/parameters/sort_by"
          },
          {
            "$ref": "#/components/parameters/direction"
          },
          {
            "schema": {
              "type": "string"
            },
            "in": "query",
            "name": "text",
            "description": "Searches in the client's name"
          },
          {
            "schema": {
              "type": "array",
              "items": {
                "type": "integer"
              }
            },
            "in": "query",
            "name": "member_ids",
            "description": "Gets only the clients that have projects there"
          },
          {
            "schema": {
              "type": "string"
            },
            "in": "header",
            "name": "Accept",
            "description": "application/json"
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "x-examples": {
                    "Example 1": {
                      "data": [
                        {
                          "client_id": 10,
                          "name": "ACME spa",
                          "color": "#F8B59B"
                        },
                        {
                          "client_id": 11,
                          "name": "Cool Company inc.",
                          "color": "#EA0A8A"
                        }
                      ],
                      "links": {
                        "first": "https://track-api.lucensoftware.com/api/v1/clients?page=1",
                        "last": "https://track-api.lucensoftware.com/api/v1/clients?page=1",
                        "prev": null,
                        "next": null
                      },
                      "meta": {
                        "current_page": 1,
                        "from": 1,
                        "last_page": 1,
                        "links": [
                          {
                            "url": null,
                            "label": "&laquo; Previous",
                            "active": false
                          },
                          {
                            "url": "https://track-api.lucensoftware.com/api/v1/clients?page=1",
                            "label": "1",
                            "active": true
                          },
                          {
                            "url": null,
                            "label": "Next &raquo;",
                            "active": false
                          }
                        ],
                        "path": "https://track-api.lucensoftware.com/api/v1/clients",
                        "per_page": 100,
                        "to": 50,
                        "total": 50
                      }
                    }
                  },
                  "properties": {
                    "data": {
                      "type": "array",
                      "items": {
                        "$ref": "#/components/schemas/Client"
                      }
                    },
                    "links": {
                      "type": "object",
                      "properties": {
                        "first": {
                          "type": "string"
                        },
                        "last": {
                          "type": "string"
                        },
                        "next": {
                          "type": "string",
                          "nullable": true
                        },
                        "prev": {
                          "type": "string",
                          "nullable": true
                        }
                      }
                    },
                    "meta": {
                      "type": "object",
                      "properties": {
                        "current_page": {
                          "type": "integer"
                        },
                        "from": {
                          "type": "integer"
                        },
                        "last_page": {
                          "type": "integer"
                        },
                        "links": {
                          "type": "array",
                          "items": {
                            "type": "object",
                            "properties": {
                              "url": {
                                "type": "string",
                                "nullable": true
                              },
                              "label": {
                                "type": "string"
                              },
                              "active": {
                                "type": "boolean"
                              }
                            }
[...]
